//SI5351_vfo + LCD + TX output Clk2 
//RX/TX offset = -800 Hz
//RX/TX offset -20...+20 kHz
//S1 Band, WSPR 600m ...10m

#include "si5351.h"
#include "Wire.h"
#include <LiquidCrystal.h>

Si5351 si5351;
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
unsigned long f = 10100;
//nsigned long  freqHz;
int pot;
long fstep;
int snr;
int r;

void setup(void)
{
  Serial.begin(9600);
  Serial.println("Si5351 Clockgen"); Serial.println("");
  // Start serial and initialize the Si5351
  si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0);  
  si5351.set_correction(162100, SI5351_PLL_INPUT_XO);
  si5351.set_pll(SI5351_PLL_FIXED, SI5351_PLLA);
  si5351.set_freq(1010100000ULL,  SI5351_CLK0);
  si5351.set_freq(4040000000ULL,  SI5351_CLK1);
  si5351.set_freq(10000ULL, SI5351_CLK2);
  si5351.output_enable(SI5351_CLK0, 1);
  si5351.output_enable(SI5351_CLK1, 1);
  si5351.output_enable(SI5351_CLK2, 0);
  lcd.begin(16, 2);
  pinMode(A0, INPUT_PULLUP);
  pinMode(A1, INPUT_PULLUP);

}



void uac(void)
{
  long uac;
    analogReference(INTERNAL);
    uac =analogRead(A2);
    uac=0;
    for (int i=0; i <= 200; i++){
       uac = uac+ analogRead(A2);
    } 
    snr = uac/50; 
    if (snr > 400) snr = 400;
    Serial.println (snr);
    snr= snr + 100;
    if (uac > 13700) uac=13700;
    r = uac*600/(14000-uac);
}


void loop(void)
{
  lcd.setCursor(0, 0);
  lcd.print (f);
  lcd.print ("  ");
  analogReference(DEFAULT);
  pot = analogRead(A3);
  pot = analogRead(A3);
  fstep = 0;
  if (pot < 200) fstep = 500;
  if (pot > 200) fstep = 100;
  if (pot > 300) fstep = 10;
  if (pot > 400) fstep = 1;
  if (pot > 500) fstep = 0;
  if (pot > 600) fstep = -1;
  if (pot > 700) fstep = -20;
  if (pot > 800) fstep = -100;
  if (pot > 900) fstep = -500;
  f = f + fstep;
  if (f < 1000) f=1000;
  if (f > 30000) f = 30000;
  si5351.set_freq(f*100000ULL, SI5351_CLK0); 
  delay(100);
  si5351.set_freq((f+5ULL)*400000ULL, SI5351_CLK1); 
  delay(200);
  uac();
   lcd.setCursor(0, 1);
  lcd.print (snr);
  lcd.print (" "); 
  lcd.print (r);
  lcd.print ("   "); 
}



